# -*- coding: utf-8 -*-
from setuphelpers import *

def install():
    # Declaring local variables
    bin_name = glob.glob("PatchCleaner_*.exe")[0]
    msi_dir = bin_name.split(".exe")[0]

    _7z_path = get_7z_path()
    if isdir(msi_dir):
        remove_tree(msi_dir)
    mkdirs(msi_dir)

    print("Extracting: %s to: %s" % (bin_name, msi_dir))
    run(r'"%s" x "%s" -aoa -o%s' % (_7z_path, bin_name, msi_dir))   # -aoa mode for overwrite mode

    # Installing the software
    msi_name = glob.glob(msi_dir + "\*.msi")[0]
    install_msi_if_needed(msi_name)

def get_7z_path():
    """
    Will get the 7zip binary path and return it

    Returns:
        path: path of 7zip binary
    """
    current_os = get_os_name()

    if "Windows" in current_os:
        path = makepath(programfiles, "7-Zip", "7z.exe")
        if isfile(path):
            return path
        path = makepath(programfiles32, "7-Zip", "7z.exe")
        if isfile(path):
            return path
        error("Couldn't find path to 7zip binary")

    elif "Darwin" in current_os:
        path = makepath("/usr", "local", "bin", "7zz")
        if isfile(path):
            return path
        path = path.strip("z")
        if isfile(path):
            return path
        error("Couldn't find path to 7zip binary")

    elif "Linux" in current_os:
        path = makepath("/usr", "local", "bin", "7zz")
        if isfile(path):
            return path
        path = path.strip("z")
        if isfile(path):
            return path
        error("Couldn't find path to 7zip binary")
